
;CodeVisionAVR C Compiler V1.25.8 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega88
;Program type           : Application
;Clock frequency        : 8,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega88
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "sd.vec"
	.INCLUDE "sd.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x4FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x4FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x200)
	LDI  R29,HIGH(0x200)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x200
;       1 /*****************************************************
;       2 Project :
;       3 Date    : 29.09.2009
;       4 Author  : Sergey
;       5 
;       6 Chip type           : ATmega88
;       7 Program type        : Application
;       8 Clock frequency     : 8,000000 MHz
;       9 Memory model        : Small
;      10 External SRAM size  : 0
;      11 Data Stack size     : 256
;      12 *****************************************************/
;      13 
;      14 #include <mega88.h>
;      15 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      16 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      17 	.EQU __se_bit=0x01
	.EQU __se_bit=0x01
;      18 	.EQU __sm_mask=0x0E
	.EQU __sm_mask=0x0E
;      19 	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_adc_noise_red=0x02
;      20 	.EQU __sm_powerdown=0x04
	.EQU __sm_powerdown=0x04
;      21 	.EQU __sm_powersave=0x06
	.EQU __sm_powersave=0x06
;      22 	.EQU __sm_standby=0x0C
	.EQU __sm_standby=0x0C
;      23 	.SET power_ctrl_reg=smcr
	.SET power_ctrl_reg=smcr
;      24 	#endif
	#endif
;      25 
;      26 // Standard Input/Output functions
;      27 #include <stdio.h>
;      28 #include <delay.h>
;      29 // SPI functions
;      30 #include <spi.h>
;      31 #include "sdio.c"
;      32 #define CS PORTB.2
;      33 #define MOSI PORTB.3
;      34 #define SCK PORTB.5
;      35 
;      36 /* Definitions for MMC/SDC command */
;      37 #define CMD0	(0x40+0)	/* GO_IDLE_STATE */
;      38 #define CMD1	(0x40+1)	/* SEND_OP_COND (MMC) */
;      39 #define	ACMD41	(0xC0+41)	/* SEND_OP_COND (SDC) */
;      40 #define CMD8	(0x40+8)	/* SEND_IF_COND */
;      41 #define CMD9	(0x40+9)	/* SEND_CSD */
;      42 #define CMD10	(0x40+10)	/* SEND_CID */
;      43 #define CMD12	(0x40+12)	/* STOP_TRANSMISSION */
;      44 #define ACMD13	(0xC0+13)	/* SD_STATUS (SDC) */
;      45 #define CMD16	(0x40+16)	/* SET_BLOCKLEN */
;      46 #define CMD17	(0x40+17)	/* READ_SINGLE_BLOCK */
;      47 #define CMD18	(0x40+18)	/* READ_MULTIPLE_BLOCK */
;      48 #define CMD23	(0x40+23)	/* SET_BLOCK_COUNT (MMC) */
;      49 #define	ACMD23	(0xC0+23)	/* SET_WR_BLK_ERASE_COUNT (SDC) */
;      50 #define CMD24	(0x40+24)	/* WRITE_BLOCK */
;      51 #define CMD25	(0x40+25)	/* WRITE_MULTIPLE_BLOCK */
;      52 #define CMD55	(0x40+55)	/* APP_CMD */
;      53 #define CMD58	(0x40+58)	/* READ_OCR */
;      54 
;      55 #define SELECT()	PORTB.2 = 0	/* PB3: MMC CS = L */
;      56 #define	DESELECT()	PORTB.2 = 1	/* PB3: MMC CS = H */
;      57 
;      58 char send_CMD(char cmd,unsigned long int arg);
;      59 void init_SD(void);
;      60 
;      61 char buffer[512];//sector buffer
_buffer:
	.BYTE 0x200
;      62 
;      63 /////// Print ULONG value to UART ///////////
;      64 void print_long(unsigned long val)
;      65 {

	.CSEG
_print_long:
;      66         unsigned char i,arr[7];
;      67 
;      68         for(i=0;i<7;i++) arr[i]=0;
	SBIW R28,7
	ST   -Y,R17
;	val -> Y+8
;	i -> R17
;	arr -> Y+1
	LDI  R17,LOW(0)
_0x4:
	CPI  R17,7
	BRSH _0x5
	RCALL SUBOPT_0x0
	LDI  R30,LOW(0)
	ST   X,R30
;      69 
;      70         while(val>=1000000) {val-=1000000;++arr[0];};
	SUBI R17,-1
	RJMP _0x4
_0x5:
_0x6:
	RCALL SUBOPT_0x1
	__CPD2N 0xF4240
	BRLO _0x8
	RCALL SUBOPT_0x2
	__SUBD1N 1000000
	RCALL SUBOPT_0x3
	LDD  R30,Y+1
	SUBI R30,-LOW(1)
	STD  Y+1,R30
	RJMP _0x6
_0x8:
;      71         while(val>=100000) {val-=100000;++arr[1];};
_0x9:
	RCALL SUBOPT_0x1
	__CPD2N 0x186A0
	BRLO _0xB
	RCALL SUBOPT_0x2
	__SUBD1N 100000
	RCALL SUBOPT_0x3
	LDD  R30,Y+2
	SUBI R30,-LOW(1)
	STD  Y+2,R30
	RJMP _0x9
_0xB:
;      72         while(val>=10000) {val-=10000;++arr[2];};
_0xC:
	RCALL SUBOPT_0x1
	__CPD2N 0x2710
	BRLO _0xE
	RCALL SUBOPT_0x2
	__SUBD1N 10000
	RCALL SUBOPT_0x3
	LDD  R30,Y+3
	SUBI R30,-LOW(1)
	STD  Y+3,R30
	RJMP _0xC
_0xE:
;      73         while(val>=1000) {val-=1000;++arr[3];};
_0xF:
	RCALL SUBOPT_0x1
	__CPD2N 0x3E8
	BRLO _0x11
	RCALL SUBOPT_0x2
	__SUBD1N 1000
	RCALL SUBOPT_0x3
	LDD  R30,Y+4
	SUBI R30,-LOW(1)
	STD  Y+4,R30
	RJMP _0xF
_0x11:
;      74         while(val>=100) {val-=100;++arr[4];};
_0x12:
	RCALL SUBOPT_0x1
	__CPD2N 0x64
	BRLO _0x14
	RCALL SUBOPT_0x2
	__SUBD1N 100
	RCALL SUBOPT_0x3
	LDD  R30,Y+5
	SUBI R30,-LOW(1)
	STD  Y+5,R30
	RJMP _0x12
_0x14:
;      75         while(val>=10) {val-=10;++arr[5];};
_0x15:
	RCALL SUBOPT_0x1
	__CPD2N 0xA
	BRLO _0x17
	RCALL SUBOPT_0x2
	__SUBD1N 10
	RCALL SUBOPT_0x3
	LDD  R30,Y+6
	SUBI R30,-LOW(1)
	STD  Y+6,R30
	RJMP _0x15
_0x17:
;      76         while(val>=1) {val-=1;++arr[6];};
_0x18:
	RCALL SUBOPT_0x1
	__CPD2N 0x1
	BRLO _0x1A
	RCALL SUBOPT_0x2
	__SUBD1N 1
	RCALL SUBOPT_0x3
	LDD  R30,Y+7
	SUBI R30,-LOW(1)
	STD  Y+7,R30
	RJMP _0x18
_0x1A:
;      77 
;      78         for(i=0;i<7;i++) putchar(arr[i]+48);
	LDI  R17,LOW(0)
_0x1C:
	CPI  R17,7
	BRSH _0x1D
	RCALL SUBOPT_0x0
	LD   R30,X
	SUBI R30,-LOW(48)
	ST   -Y,R30
	RCALL _putchar
;      79         putchar('\n');
	SUBI R17,-1
	RJMP _0x1C
_0x1D:
	LDI  R30,LOW(10)
	ST   -Y,R30
	RCALL _putchar
;      80 }
	LDD  R17,Y+0
	ADIW R28,12
	RET
;      81 
;      82 ////////// Transmitt sector to UART ////////////////
;      83 void tx_sector(void)
;      84 {
;      85         unsigned int i;
;      86 
;      87         for(i=0;i<512;i++) putchar(buffer[i]);
;	i -> R16,R17
;      88 }
;      89 
;      90 /// Load single sector into RAM buffer[512] ///
;      91 char load_sector(unsigned long adr )
;      92 {
_load_sector:
;      93         unsigned int i;
;      94         unsigned char n;
;      95 
;      96         n=10;
	RCALL __SAVELOCR4
;	adr -> Y+4
;	i -> R16,R17
;	n -> R19
	LDI  R19,LOW(10)
;      97         while((send_CMD(CMD17,adr)!=0) && n) --n;
_0x21:
	LDI  R30,LOW(81)
	ST   -Y,R30
	__GETD1S 5
	RCALL SUBOPT_0x4
	CPI  R30,0
	BREQ _0x24
	CPI  R19,0
	BRNE _0x25
_0x24:
	RJMP _0x23
_0x25:
	SUBI R19,LOW(1)
;      98         if(!n) return 1;
	RJMP _0x21
_0x23:
	CPI  R19,0
	BRNE _0x26
	LDI  R30,LOW(1)
	RJMP _0x122
;      99 
;     100         while(spi(0xFF)!=0xFE);//wait for start of transmission
_0x26:
_0x27:
	RCALL SUBOPT_0x5
	CPI  R30,LOW(0xFE)
	BRNE _0x27
;     101 
;     102         for(i=0;i<512;i++)
	__GETWRN 16,17,0
_0x2B:
	__CPWRN 16,17,512
	BRSH _0x2C
;     103                 {
;     104                 buffer[i]=spi(0xFF);
	MOVW R30,R16
	SUBI R30,LOW(-_buffer)
	SBCI R31,HIGH(-_buffer)
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x5
	POP  R26
	POP  R27
	ST   X,R30
;     105                 };
	__ADDWRN 16,17,1
	RJMP _0x2B
_0x2C:
;     106         spi(0xFF);//
	RCALL SUBOPT_0x5
;     107         spi(0xFF);//read 2 bytes CRC
	RCALL SUBOPT_0x5
;     108         return 0;
	LDI  R30,LOW(0)
_0x122:
	RCALL __LOADLOCR4
	ADIW R28,8
	RET
;     109 }
;     110 
;     111 //////// Init SPI mode for SD card //////
;     112 void init_SD(void)
;     113 {
_init_SD:
;     114         unsigned char i;
;     115 start:
	ST   -Y,R17
;	i -> R17
_0x2D:
;     116         SCK=1;
	SBI  0x5,5
;     117         CS=1;
	SBI  0x5,2
;     118         MOSI=1;
	SBI  0x5,3
;     119 
;     120         for(i=0;i<100;i++)
	LDI  R17,LOW(0)
_0x35:
	CPI  R17,100
	BRSH _0x36
;     121                 spi(0xFF);
	RCALL SUBOPT_0x5
;     122         CS=0;
	SUBI R17,-1
	RJMP _0x35
_0x36:
	CBI  0x5,2
;     123 
;     124         send_CMD(CMD0,0);//Reset card
	LDI  R30,LOW(64)
	RCALL SUBOPT_0x6
;     125         /*if(send_CMD(CMD0,0)==0x01)
;     126                 putsf("0x01 = CMD0 OK");
;     127         else
;     128                 putsf("CMD0 incorrect");
;     129 
;     130         putsf("Sending CMD1"); */
;     131         i=0;
	LDI  R17,LOW(0)
;     132         while((send_CMD(CMD1,0)!=0x00)&&(i<250))++i;//Set SPI mode
_0x39:
	LDI  R30,LOW(65)
	RCALL SUBOPT_0x6
	CPI  R30,0
	BREQ _0x3C
	CPI  R17,250
	BRLO _0x3D
_0x3C:
	RJMP _0x3B
_0x3D:
	SUBI R17,-LOW(1)
;     133         if(i==250) goto start;//If lailed then again
	RJMP _0x39
_0x3B:
	CPI  R17,250
	BREQ _0x2D
;     134         //putsf("0x00 = CMD1 OK");
;     135 }
	RJMP _0x121
;     136 
;     137 //static
;     138 char wait_ready (void)
;     139 {
_wait_ready:
;     140 	char res;
;     141 
;     142 	spi(0xFF);
	ST   -Y,R17
;	res -> R17
	RCALL SUBOPT_0x5
;     143 	do
_0x40:
;     144 		res = spi(0xFF);
	RCALL SUBOPT_0x5
	MOV  R17,R30
;     145 	while (res != 0xFF);
	CPI  R17,255
	BRNE _0x40
;     146 
;     147 	return res;
	MOV  R30,R17
_0x121:
	LD   R17,Y+
	RET
;     148 }
;     149 
;     150 char send_CMD(char cmd,unsigned long int arg)
;     151 {
_send_CMD:
;     152 	char n, res;
;     153 
;     154 
;     155 	if (cmd & 0x80) {	/* ACMD<n> is the command sequense of CMD55-CMD<n> */
	RCALL __SAVELOCR2
;	cmd -> Y+6
;	arg -> Y+2
;	n -> R17
;	res -> R16
	LDD  R30,Y+6
	ANDI R30,LOW(0x80)
	BREQ _0x42
;     156 		cmd &= 0x7F;
	LDD  R30,Y+6
	ANDI R30,0x7F
	STD  Y+6,R30
;     157 		res = send_CMD(CMD55, 0);
	LDI  R30,LOW(119)
	RCALL SUBOPT_0x6
	MOV  R16,R30
;     158 		if (res > 1) return res;
	CPI  R16,2
	BRLO _0x43
	MOV  R30,R16
	RJMP _0x120
;     159 	}
_0x43:
;     160 
;     161 	/* Select the card and wait for ready */
;     162 	DESELECT();
_0x42:
	SBI  0x5,2
;     163 	SELECT();
	CBI  0x5,2
;     164 	if (wait_ready() != 0xFF) return 0xFF;
	RCALL _wait_ready
	CPI  R30,LOW(0xFF)
	BREQ _0x48
	LDI  R30,LOW(255)
	RJMP _0x120
;     165 
;     166 	/* Send command packet */
;     167 	spi(cmd);		        /* Start + Command index */
_0x48:
	LDD  R30,Y+6
	RCALL SUBOPT_0x7
;     168 	spi((char)(arg >> 24));		/* Argument[31..24] */
	RCALL SUBOPT_0x8
	LDI  R30,LOW(24)
	RCALL __LSRD12
	RCALL SUBOPT_0x7
;     169 	spi((char)(arg >> 16));		/* Argument[23..16] */
	__GETD1S 2
	RCALL __LSRD16
	RCALL SUBOPT_0x7
;     170 	spi((char)(arg >> 8));		/* Argument[15..8] */
	RCALL SUBOPT_0x8
	LDI  R30,LOW(8)
	RCALL __LSRD12
	RCALL SUBOPT_0x7
;     171 	spi((char)arg);			/* Argument[7..0] */
	LDD  R30,Y+2
	RCALL SUBOPT_0x7
;     172 	n = 0x01;			/* Dummy CRC + Stop */
	LDI  R17,LOW(1)
;     173 	if (cmd == CMD0) n = 0x95;	/* Valid CRC for CMD0(0) */
	LDD  R26,Y+6
	CPI  R26,LOW(0x40)
	BRNE _0x49
	LDI  R17,LOW(149)
;     174 	if (cmd == CMD8) n = 0x87;	/* Valid CRC for CMD8(0x1AA) */
_0x49:
	LDD  R26,Y+6
	CPI  R26,LOW(0x48)
	BRNE _0x4A
	LDI  R17,LOW(135)
;     175 	spi(n);
_0x4A:
	ST   -Y,R17
	RCALL _spi
;     176 
;     177 	/* Receive command response */
;     178 	n = 100;			/* Wait for a valid response in timeout of 10 attempts */
	LDI  R17,LOW(100)
;     179 	do {
_0x4C:
;     180 		res = spi(0xFF);
	RCALL SUBOPT_0x5
	MOV  R16,R30
;     181 	} while ((res & 0x80) && --n);
	SBRS R16,7
	RJMP _0x4E
	SUBI R17,LOW(1)
	CPI  R17,0
	BRNE _0x4F
_0x4E:
	RJMP _0x4D
_0x4F:
	RJMP _0x4C
_0x4D:
;     182 
;     183 	return res;			/* Return with the response value */
	MOV  R30,R16
_0x120:
	RCALL __LOADLOCR2
	ADIW R28,7
	RET
;     184 }
;     185 #include "fat.c"
;     186 unsigned long pbr_adr, fat_base,root_base, cluster_base;

	.DSEG
_pbr_adr:
	.BYTE 0x4
_fat_base:
	.BYTE 0x4
_root_base:
	.BYTE 0x4
_cluster_base:
	.BYTE 0x4
;     187 unsigned long number_of_fat,sectors_per_fat,reserved;
_number_of_fat:
	.BYTE 0x4
_sectors_per_fat:
	.BYTE 0x4
_reserved:
	.BYTE 0x4
;     188 unsigned long root_dir_entry,root_entry_size,sectors_per_cluster;
_root_dir_entry:
	.BYTE 0x4
_root_entry_size:
	.BYTE 0x4
_sectors_per_cluster:
	.BYTE 0x4
;     189 
;     190 
;     191 void get_FAT(void)
;     192 {

	.CSEG
;     193         //unsigned char response;
;     194         //unsigned long tmp[4];
;     195         /////////////////////////////////////////////
;     196         load_sector(0);//load MBR sector
;     197 
;     198         //pbr_adr=((unsigned long) buffer[456])*65536;
;     199         //pbr_adr+=((unsigned long)buffer[455])*256;
;     200         //pbr_adr+=buffer[454];
;     201 
;     202         pbr_adr= ((unsigned long)buffer[0x01C8])<<16;
;     203         pbr_adr+=((unsigned long)buffer[0x01C7])<<8;
;     204         pbr_adr+=buffer[0x01C6];
;     205 
;     206         printf("PBR abress:");
;     207         print_long(pbr_adr);
;     208         /////////////////////////////////////////////
;     209         load_sector(pbr_adr);//load PBR sector
;     210 
;     211         sectors_per_cluster=buffer[0x0D];
;     212         printf("sector per cluster:");
;     213         print_long(sectors_per_cluster);
;     214 
;     215         reserved=((unsigned long)buffer[0x0F])*256+buffer[0x0E];
;     216         printf("reserved sectors:");
;     217         print_long(reserved);
;     218 
;     219         number_of_fat=buffer[0x10];
;     220         printf("number of fat:");
;     221         print_long(number_of_fat);
;     222 
;     223         root_dir_entry=buffer[0x11]+(((unsigned long) buffer[0x12])*256);
;     224         printf("root dir entry:");
;     225         print_long(root_dir_entry);
;     226 
;     227         sectors_per_fat=buffer[0x16]+((unsigned long) buffer[0x17])*256;
;     228         printf("sectors per fat:");
;     229         print_long(sectors_per_fat);
;     230         ////////////////////////////////////////////
;     231         fat_base=pbr_adr+reserved;
;     232         root_base=fat_base+number_of_fat*sectors_per_fat;
;     233         cluster_base=root_base+root_dir_entry*root_entry_size-2*sectors_per_cluster;
;     234 
;     235 }
;     236 // Declare your global variables here
;     237 
;     238 void main(void)
;     239 {
_main:
;     240 // Declare your local variables here
;     241 unsigned long block_pointer=0,i,n;
;     242 // Crystal Oscillator division factor: 1
;     243 #pragma optsize-
;     244 CLKPR=0x80;
	SBIW R28,12
	LDI  R24,4
	LDI  R26,LOW(8)
	LDI  R27,HIGH(8)
	LDI  R30,LOW(_0x50*2)
	LDI  R31,HIGH(_0x50*2)
	RCALL __INITLOCB
;	block_pointer -> Y+8
;	i -> Y+4
;	n -> Y+0
	LDI  R30,LOW(128)
	STS  97,R30
;     245 CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
;     246 #ifdef _OPTIMIZE_SIZE_
;     247 #pragma optsize+
;     248 #endif
;     249 
;     250 // Input/Output Ports initialization
;     251 // Port B initialization
;     252 // Func7=In Func6=In Func5=In Func4=Out Func3=In Func2=Out Func1=In Func0=In
;     253 // State7=T State6=T State5=T State4=0 State3=T State2=1 State1=T State0=T
;     254 PORTB=0x04;
	LDI  R30,LOW(4)
	OUT  0x5,R30
;     255 DDRB=0b00101100;//0x14;
	LDI  R30,LOW(44)
	OUT  0x4,R30
;     256 
;     257 // Port C initialization
;     258 // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     259 // State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     260 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x8,R30
;     261 DDRC=0x00;
	OUT  0x7,R30
;     262 
;     263 // Port D initialization
;     264 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=In
;     265 // State7=T State6=T State5=T State4=T State3=T State2=T State1=0 State0=T
;     266 PORTD=0x00;
	OUT  0xB,R30
;     267 DDRD=0x02;
	LDI  R30,LOW(2)
	OUT  0xA,R30
;     268 
;     269 // Timer/Counter 0 initialization
;     270 // Clock source: System Clock
;     271 // Clock value: Timer 0 Stopped
;     272 // Mode: Normal top=FFh
;     273 // OC0A output: Disconnected
;     274 // OC0B output: Disconnected
;     275 TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;     276 TCCR0B=0x00;
	OUT  0x25,R30
;     277 TCNT0=0x00;
	OUT  0x26,R30
;     278 OCR0A=0x00;
	OUT  0x27,R30
;     279 OCR0B=0x00;
	OUT  0x28,R30
;     280 
;     281 // Timer/Counter 1 initialization
;     282 // Clock source: System Clock
;     283 // Clock value: Timer 1 Stopped
;     284 // Mode: Normal top=FFFFh
;     285 // OC1A output: Discon.
;     286 // OC1B output: Discon.
;     287 // Noise Canceler: Off
;     288 // Input Capture on Falling Edge
;     289 // Timer 1 Overflow Interrupt: Off
;     290 // Input Capture Interrupt: Off
;     291 // Compare A Match Interrupt: Off
;     292 // Compare B Match Interrupt: Off
;     293 TCCR1A=0x00;
	STS  128,R30
;     294 TCCR1B=0x00;
	STS  129,R30
;     295 TCNT1H=0x00;
	STS  133,R30
;     296 TCNT1L=0x00;
	STS  132,R30
;     297 ICR1H=0x00;
	STS  135,R30
;     298 ICR1L=0x00;
	STS  134,R30
;     299 OCR1AH=0x00;
	STS  137,R30
;     300 OCR1AL=0x00;
	STS  136,R30
;     301 OCR1BH=0x00;
	STS  139,R30
;     302 OCR1BL=0x00;
	STS  138,R30
;     303 
;     304 // Timer/Counter 2 initialization
;     305 // Clock source: System Clock
;     306 // Clock value: Timer 2 Stopped
;     307 // Mode: Normal top=FFh
;     308 // OC2A output: Disconnected
;     309 // OC2B output: Disconnected
;     310 ASSR=0x00;
	STS  182,R30
;     311 TCCR2A=0x00;
	STS  176,R30
;     312 TCCR2B=0x00;
	STS  177,R30
;     313 TCNT2=0x00;
	STS  178,R30
;     314 OCR2A=0x00;
	STS  179,R30
;     315 OCR2B=0x00;
	STS  180,R30
;     316 
;     317 // External Interrupt(s) initialization
;     318 // INT0: Off
;     319 // INT1: Off
;     320 // Interrupt on any change on pins PCINT0-7: Off
;     321 // Interrupt on any change on pins PCINT8-14: Off
;     322 // Interrupt on any change on pins PCINT16-23: Off
;     323 EICRA=0x00;
	STS  105,R30
;     324 EIMSK=0x00;
	OUT  0x1D,R30
;     325 PCICR=0x00;
	STS  104,R30
;     326 
;     327 // Timer/Counter 0 Interrupt(s) initialization
;     328 TIMSK0=0x00;
	STS  110,R30
;     329 // Timer/Counter 1 Interrupt(s) initialization
;     330 TIMSK1=0x00;
	STS  111,R30
;     331 // Timer/Counter 2 Interrupt(s) initialization
;     332 TIMSK2=0x00;
	STS  112,R30
;     333 
;     334 // USART initialization
;     335 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     336 // USART Receiver: Off
;     337 // USART Transmitter: On
;     338 // USART0 Mode: Asynchronous
;     339 // USART Baud Rate: 9600
;     340 UCSR0A=0x00;
	STS  192,R30
;     341 UCSR0B=0x08;
	LDI  R30,LOW(8)
	STS  193,R30
;     342 UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  194,R30
;     343 UBRR0H=0x00;
	LDI  R30,LOW(0)
	STS  197,R30
;     344 UBRR0L=0x33;
	LDI  R30,LOW(51)
	STS  196,R30
;     345 
;     346 // Analog Comparator initialization
;     347 // Analog Comparator: Off
;     348 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     349 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x30,R30
;     350 ADCSRB=0x00;
	LDI  R30,LOW(0)
	STS  123,R30
;     351 
;     352 // SPI initialization
;     353 // SPI Type: Slave
;     354 // SPI Clock Rate: 2000,000 kHz
;     355 // SPI Clock Phase: Cycle Half
;     356 // SPI Clock Polarity: Low
;     357 // SPI Data Order: MSB First
;     358 SPCR=0x53;//(62,5KHz)//40;
	LDI  R30,LOW(83)
	OUT  0x2C,R30
;     359 SPSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     360 //125KHz
;     361 //SPCR=0x52;
;     362 //SPSR=0x00;
;     363 
;     364 delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0x9
	RCALL _delay_ms
;     365 
;     366 init_SD();
	RCALL _init_SD
;     367 
;     368 //get_FAT();
;     369 //send_CMD(CMD18,0);//Multiple block read
;     370 for(i=0;i<=1000;i++)
	__CLRD1S 4
_0x52:
	__GETD2S 4
	__CPD2N 0x3E9
	BRSH _0x53
;     371 {
;     372 if(load_sector(i))
	RCALL SUBOPT_0xA
	RCALL _load_sector
	CPI  R30,0
	BREQ _0x54
;     373         {
;     374         printf("\rread error, sector#");
	__POINTW1FN _0,98
	RCALL SUBOPT_0x9
	LDI  R24,0
	RCALL _printf
	ADIW R28,2
;     375         print_long(i);
	RCALL SUBOPT_0xA
	RCALL _print_long
;     376         };
_0x54:
;     377 //delay_ms(20);
;     378 //tx_sector();
;     379 };
	__GETD1S 4
	__SUBD1N -1
	__PUTD1S 4
	RJMP _0x52
_0x53:
;     380 
;     381 while (1)
_0x55:
;     382       {
;     383       // Place your code here
;     384 
;     385       };
	RJMP _0x55
;     386 }
_0x58:
	RJMP _0x58

	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.SET power_ctrl_reg=smcr
	#endif
_putchar:
_0x5C:
	LDS  R30,192
	ANDI R30,LOW(0x20)
	BREQ _0x5C
	LD   R30,Y
	STS  198,R30
	ADIW R28,1
	RET
__put_G2:
	RCALL __SAVELOCR2
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x6C
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x6E
	__CPWRN 16,17,2
	BRLO _0x6F
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x6E:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x6F:
	RJMP _0x70
_0x6C:
	LDD  R30,Y+6
	ST   -Y,R30
	RCALL _putchar
_0x70:
	RCALL __LOADLOCR2
	ADIW R28,7
	RET
__print_G2:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
_0x71:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x73
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x77
	CPI  R18,37
	BRNE _0x78
	LDI  R17,LOW(1)
	RJMP _0x79
_0x78:
	RCALL SUBOPT_0xB
_0x79:
	RJMP _0x76
_0x77:
	CPI  R30,LOW(0x1)
	BRNE _0x7A
	CPI  R18,37
	BRNE _0x7B
	RCALL SUBOPT_0xB
	RJMP _0x123
_0x7B:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x7C
	LDI  R16,LOW(1)
	RJMP _0x76
_0x7C:
	CPI  R18,43
	BRNE _0x7D
	LDI  R20,LOW(43)
	RJMP _0x76
_0x7D:
	CPI  R18,32
	BRNE _0x7E
	LDI  R20,LOW(32)
	RJMP _0x76
_0x7E:
	RJMP _0x7F
_0x7A:
	CPI  R30,LOW(0x2)
	BRNE _0x80
_0x7F:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x81
	ORI  R16,LOW(128)
	RJMP _0x76
_0x81:
	RJMP _0x82
_0x80:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x76
_0x82:
	CPI  R18,48
	BRLO _0x85
	CPI  R18,58
	BRLO _0x86
_0x85:
	RJMP _0x84
_0x86:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x76
_0x84:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x8A
	RCALL SUBOPT_0xC
	LD   R30,X
	RCALL SUBOPT_0xD
	RJMP _0x8B
_0x8A:
	CPI  R30,LOW(0x73)
	BRNE _0x8D
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xE
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x8E
_0x8D:
	CPI  R30,LOW(0x70)
	BRNE _0x90
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xE
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x8E:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x91
_0x90:
	CPI  R30,LOW(0x64)
	BREQ _0x94
	CPI  R30,LOW(0x69)
	BRNE _0x95
_0x94:
	ORI  R16,LOW(4)
	RJMP _0x96
_0x95:
	CPI  R30,LOW(0x75)
	BRNE _0x97
_0x96:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	RCALL SUBOPT_0xF
	LDI  R17,LOW(5)
	RJMP _0x98
_0x97:
	CPI  R30,LOW(0x58)
	BRNE _0x9A
	ORI  R16,LOW(8)
	RJMP _0x9B
_0x9A:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0xCC
_0x9B:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	RCALL SUBOPT_0xF
	LDI  R17,LOW(4)
_0x98:
	SBRS R16,2
	RJMP _0x9D
	RCALL SUBOPT_0xC
	RCALL __GETW1P
	RCALL SUBOPT_0x10
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x9E
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	RCALL SUBOPT_0x10
	LDI  R20,LOW(45)
_0x9E:
	CPI  R20,0
	BREQ _0x9F
	SUBI R17,-LOW(1)
	RJMP _0xA0
_0x9F:
	ANDI R16,LOW(251)
_0xA0:
	RJMP _0xA1
_0x9D:
	RCALL SUBOPT_0xC
	RCALL __GETW1P
	RCALL SUBOPT_0x10
_0xA1:
_0x91:
	SBRC R16,0
	RJMP _0xA2
_0xA3:
	CP   R17,R21
	BRSH _0xA5
	SBRS R16,7
	RJMP _0xA6
	SBRS R16,2
	RJMP _0xA7
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0xA8
_0xA7:
	LDI  R18,LOW(48)
_0xA8:
	RJMP _0xA9
_0xA6:
	LDI  R18,LOW(32)
_0xA9:
	RCALL SUBOPT_0xB
	SUBI R21,LOW(1)
	RJMP _0xA3
_0xA5:
_0xA2:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0xAA
_0xAB:
	CPI  R19,0
	BREQ _0xAD
	SBRS R16,3
	RJMP _0xAE
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	RCALL SUBOPT_0xF
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x124
_0xAE:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x124:
	ST   -Y,R30
	RCALL SUBOPT_0x11
	CPI  R21,0
	BREQ _0xB0
	SUBI R21,LOW(1)
_0xB0:
	SUBI R19,LOW(1)
	RJMP _0xAB
_0xAD:
	RJMP _0xB1
_0xAA:
_0xB3:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	RCALL SUBOPT_0xF
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0xB5:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0xB7
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0x10
	RJMP _0xB5
_0xB7:
	CPI  R18,58
	BRLO _0xB8
	SBRS R16,3
	RJMP _0xB9
	SUBI R18,-LOW(7)
	RJMP _0xBA
_0xB9:
	SUBI R18,-LOW(39)
_0xBA:
_0xB8:
	SBRC R16,4
	RJMP _0xBC
	CPI  R18,49
	BRSH _0xBE
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0xBD
_0xBE:
	RJMP _0x125
_0xBD:
	CP   R21,R19
	BRLO _0xC2
	SBRS R16,0
	RJMP _0xC3
_0xC2:
	RJMP _0xC1
_0xC3:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0xC4
	LDI  R18,LOW(48)
_0x125:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0xC5
	ANDI R16,LOW(251)
	ST   -Y,R20
	RCALL SUBOPT_0x11
	CPI  R21,0
	BREQ _0xC6
	SUBI R21,LOW(1)
_0xC6:
_0xC5:
_0xC4:
_0xBC:
	RCALL SUBOPT_0xB
	CPI  R21,0
	BREQ _0xC7
	SUBI R21,LOW(1)
_0xC7:
_0xC1:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0xB4
	RJMP _0xB3
_0xB4:
_0xB1:
	SBRS R16,0
	RJMP _0xC8
_0xC9:
	CPI  R21,0
	BREQ _0xCB
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0xD
	RJMP _0xC9
_0xCB:
_0xC8:
_0xCC:
_0x8B:
_0x123:
	LDI  R17,LOW(0)
_0x76:
	RJMP _0x71
_0x73:
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	RCALL __SAVELOCR2
	MOVW R26,R28
	RCALL __ADDW2R15
	MOVW R16,R26
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0x9
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	RCALL SUBOPT_0x9
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0x9
	RCALL __print_G2
	RCALL __LOADLOCR2
	ADIW R28,4
	POP  R15
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.SET power_ctrl_reg=smcr
	#endif
_spi:
	LD   R30,Y
	OUT  0x2E,R30
_0x118:
	IN   R30,0x2D
	SBRS R30,7
	RJMP _0x118
	IN   R30,0x2E
	ADIW R28,1
	RET
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
    lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.DSEG
_p_S4C:
	.BYTE 0x2

	.CSEG

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x0:
	MOV  R30,R17
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,1
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x1:
	__GETD2S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x2:
	__GETD1S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x3:
	__PUTD1S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	RCALL __PUTPARD1
	RJMP _send_CMD

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(255)
	ST   -Y,R30
	RJMP _spi

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x6:
	ST   -Y,R30
	__GETD1N 0x0
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7:
	ST   -Y,R30
	RJMP _spi

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	__GETD2S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 23 TIMES, CODE SIZE REDUCTION:20 WORDS
SUBOPT_0x9:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xA:
	__GETD1S 4
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0xB:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x9
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x9
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0xC:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	SBIW R26,4
	STD  Y+16,R26
	STD  Y+16+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xD:
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x9
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x9
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xE:
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10:
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x11:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x9
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x9
	RJMP __put_G2

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__LSRD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSRD12R
__LSRD12L:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRD12L
__LSRD12R:
	RET

__LSRD16:
	MOV  R30,R22
	MOV  R31,R23
	LDI  R22,0
	LDI  R23,0
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
